#! /usr/bin/python  
import ConfigParser, os, MySQLdb, sys, string;

syntax="""
Syntax : check_meta.py configfile metaservice
"""
OK='OK'
WARNING='WARNING'
CRITICAL='CRITICAL'
UNKNOWN='UNKNOWN'
status = [ "OK", "WARNING", "CRITICAL", "UNKNOWN" ]
def loadConfig(configfile,metaName):
    config = ConfigParser.ConfigParser();
    try:
	fp=open(configfile);
    except IOError, (errno, strerror):
	print("Unable to load file " + configfile );
    	sys.exit(1);
    config.readfp(fp);
    if( (len(config.sections()) < 3) | (not config.has_section("db")) | (not config.has_section("aliases")) | (not config.has_section(metaName))):
	print "Incomplete config file or missing section";
	sys.exit(1);
    
    return(config);
    

def parseDBConfig(config):
    dbparams = {};
    try:
	dbparams["db"]=config.get("db","db");
	dbparams["user"] = config.get("db","user") ;
	dbparams["passwd"]= config.get("db","passwd");
        dbparams["host"]= config.get("db","host");
	dbparams["port"]= int(config.get("db","port"));
    except:
	print("Incomplete or bad config file section [db]");
	sys.exit(1);
    return(dbparams);

def parseAlias(config):
    try:
	
	alias = {};
	for x in config.options("aliases"):
	    alias[x]=config.get("aliases", x);
    except:
	print "Incomplete or bad config file section [aliases]";
	sys.exit(1);
		 
    return(alias);
    

def parseMeta(config,alias,metaName):
    try:	
	if(not config.has_option(metaName, "uses")) :
	    print("Missing option 'uses' for metaservice " + metaName);
	    sys.exit(1);
	expr=config.options(metaName);
	expr.remove("uses");
	if( ("warning" not in expr) and ("critical" not in expr) and ("ok" not in expr) and ("unknown" not in expr) and ("default" not in expr)):
	    print "No state defined for metaservice " + metaName ;
	    sys.exit(1);
	
	for y in string.split(config.get(metaName, "uses"), ','):
	    if y not in alias:
		print "Sorry, " + y + " was not defined in [aliases]";
		sys.exit(1);
		# I could add only aliases used in expression
	exprs = {};
	if config.has_option(metaName, "ok"):
		exprs["ok"] = config.get(metaName, "ok");
	if config.has_option(metaName, "critical"):
		exprs["critical"] = config.get(metaName, "critical");
	if config.has_option(metaName, "warning"):
		exprs["warning"] = config.get(metaName, "warning");
	if config.has_option(metaName, "unknown"):
		exprs["unknown"] = config.get(metaName, "unknown");
	if config.has_option(metaName, "default"):
		exprs["default"] = config.get(metaName, "default");
    except:
	print "Incomplete or bad config file section META";
	sys.exit(1);
    return(exprs);
    
	
def evalMeta(exprs, alias, dbparams):
    try:
    	results = {};
	db = MySQLdb.connect(**dbparams);
	for key in exprs.keys():
		expr = exprs[key];
		for x in alias.keys():
			cursor = db.cursor()
			cursor.execute("SELECT service_status  FROM servicestatus where service_description like '" + alias[x] + "'")
			result = cursor.fetchall()
	   		for record in result:
				expr = string.replace(expr, x, record[0])		
	   	expr = string.replace(expr, 'OK', '0');
		expr = string.replace(expr, 'WARNING', '1');
		expr = string.replace(expr, 'CRITICAL', '2');
		expr = string.replace(expr, 'UNKNOWN', '3');
		results[key] = eval(expr);
		
		
    except Exception, e:
	print("Db connexion failure");
	print e;
	sys.exit(1);
    return(results);
    sys.exit(0);
	


if(len(sys.argv) < 3) :
    print(syntax);
    sys.exit(0);
metaName=sys.argv[2];
configFile=sys.argv[1];
config=loadConfig(configFile, metaName);
dbparams=parseDBConfig(config);
alias=parseAlias(config);
exprs=parseMeta(config,alias,metaName);
results=evalMeta(exprs, alias, dbparams);
if results.has_key("critical") and results["critical"]:
	print "Metaservice " + metaName + " : CRITICAL"
	sys.exit(2);
if results.has_key("warning") and results["warning"]:
    	print "Metaservice " + metaName + " : WARNING"
	sys.exit(1);
if results.has_key("unknown") and results["unknown"]:
    	print "Metaservice " +  metaName + " : UNKNOWN"
	sys.exit(3);
if results.has_key("ok") and results["ok"]:
    	print "Metaservice " +  metaName + " : OK"
	sys.exit(0);
if results.has_key("default"):
	r = results["default"]
	print "Metaservice %s : %s (default)" % (metaName,status[r])
	sys.exit(r);
